//b:end判断上有问题
;
(function($) {
    $.fn.oldtreeview = function(settings) {
        var dfop =
        {
            method: "POST",
            datatype: "json",
            url: false,
            cbiconpath: FR.servletURL + "?op=resource&resource=/com/fr/web/core/js/jquerytree/images/icons/",
            icons: ["checkbox_0.gif", "checkbox_1.gif", "checkbox_2.gif"],
            showcheck: false, //是否显示选择
            oncheckboxclick: false, //当checkstate状态变化时所触发的事件，但是不会触发因级联选择而引起的变化
            onnodeclick: false,
            afterAjax:false,// ajax完成后需要触发的事件
            cascadecheck: true,
            data: null,
            traversal : 0, // 分为0，1，2共3种类型
            clicktoggle: true, //点击节点展开和收缩子节点
            noParent : true,

            theme: "fr-tree-no-lines", //fr-tree-lines ,fr-tree-no-lines,fr-tree-arrows
            expandClass:"fr-tree-elbow-plus-old",
            closeClass:"fr-tree-elbow-minus-old",
            expandEndClass:"fr-tree-elbow-end-plus-old",
            closeEndClass:"fr-tree-elbow-end-minus-old",
            beforeSelectItemChange : function() {
                return true;
            }
        }
        var isLoadingData = false;
        var loadPoint = [];
        $.extend(dfop, settings);
        var treenodes;
        var me = $(this);
        var that = dfop.widget;
        var id = me.attr("id");
        if (id == null || id == "") {
            id = "bbtree" + new Date().getTime();
            me.attr("id",  id);
        }
        me.unbind('scroll');
        //wei : treedata现在使用的是异步数据。
        if(dfop.data instanceof FR.SynchronTreeData) {
            dfop.data.afterRead(function(nodes) {
                me.__loadingMoreData__(true);
                treenodes = nodes;
                createTree(nodes);
                dfop.widget.fireEvent(FR.Events.DEFAULTINIT);
                checkPoint(nodes);
                me.__loadingMoreData__(false);
            });
        } else {
            var nodes = dfop.data.getData();
            me.__loadingMoreData__(true);
            treenodes = nodes;
            createTree(nodes);
            dfop.widget.fireEvent(FR.Events.DEFAULTINIT);
            checkPoint(nodes);
            me.__loadingMoreData__(false);
        }

        dfop.data.appendDataEvent(function(nodes) {
            me.__loadingMoreData__(true);
            checkPoint(nodes);
            insertNodes(nodes);
            isLoadingData = false;
            me.__loadingMoreData__(false);
        });

        me.addClass("fr-tree");
        addScrollEvent();
        dfop.data.loadNodes();
        //预加载图片
        if (dfop.showcheck) {
            for (var i = 0; i < 3; i++) {
                var im = new Image();
                im.src = dfop.cbiconpath + dfop.icons[i];
            }
        }

        function checkPoint(nodes) {
            if (nodes.length >= dfop.widget.options.limitData) {
                loadPoint.push(nodes[nodes.length - 1]);
                return true;
            }
            return false;
        }

        function removeSrollPoint(node) {
            loadPoint.remove(node);
        }

        function addScrollEvent() {
            me.scroll(function(e) {
                if (loadPoint.length > 0) {
                    var scrollTop = me.scrollTop();
                    for (var i = 0, len = loadPoint.length; i < len; i++) {
                        if (scrollTop >= need2LoadNode(loadPoint[i])) {
                            loadAdditionalNodes(loadPoint[i]);
                        }
                    }
                }
            });
        }

        function loadAdditionalNodes(node) {
            if (isLoadingData) {
                return;
            }
            isLoadingData = true;

            if (!node.getParent()) {
                var rootdata = dfop.widget.options.data;
                rootdata.resetStatus4AddRootNodes(allPara(dfop.widget.options.data.getChildrenLength()));
                rootdata.loadNodes();
            } else {
                //b:这里遗留了 treeNode的加载问题,to improve
                node.getParent().resetStatus4AddNodes(allPara(node.getParent().getChildrenLength()));
                var data = node.getParent().getAdditionalNodes();
                checkPoint(data);
                insertNodes(data);
                isLoadingData = false;
            }
            //b:在loaddata后remove更好
            removeSrollPoint(node);
        }

        function allPara(start, limit) {
            var config = dfop.widget.createDependencePara4Data();
            config.parameter.startIndex = start ? start : 0;
            config.parameter.limitIndex = limit ? limit : dfop.widget.options.limitData;
            return config;
        }

        function need2LoadNode(node) {
            return me[0].scrollHeight*getNodePosition(node)/getAllShowNodesLength() - me.height();
        }

        function getAllShowNodesLength() {
            return $('li:visible', me).length;
        }

        function getNodePosition(node) {
            var showNodes = $('li:visible', me);
            for (var i = 0, len = getAllShowNodesLength(); i < len; i++) {
                if (node.ui[0] == showNodes[i]) {
                    return i + 1;
                }
            }
            return 0;
        }


        function insertNodes(nodes) {
            if (nodes.length < 1) {
                return;
            }
            dfop.widget.fireEvent("nodeadd", nodes);
            var parent = nodes[0].getParent();
            if (parent) {
                var ul;
                if (parent.ui.children('ul').length > 0) {
                    ul = parent.ui.children('ul');
                } else {
                    ul = createWrapUL();
                    parent.ui.append(ul);
                }

                var isShow = true;
                if (!parent.ui.is(':visible')) {
                    ul.hide();
                    isShow = false;
                }
                var frag = document.createDocumentFragment();
                for (var i = 0, len = nodes.length; i < len; i++) {
                    var li = createTreeNode(nodes[i]);
                    if (!isShow) {
                        li.hide();
                    }
                    frag.appendChild(li[0]);
                }
                ul[0].appendChild(frag);
            } else {
                var rootul = $('ul.fr-tree-root', me);
                var frag = document.createDocumentFragment();
                for (var i = 0, len = nodes.length; i < len; i++) {
                    var li = createTreeNode(nodes[i]);
                    frag.appendChild(li[0]);
                }
                rootul[0].appendChild(frag);
            }
        }

        function createTree(nodes) {
            dfop.widget.fireEvent("nodeadd", nodes);
            var rootul = $('<ul/>').addClass('fr-tree-root ' + dfop.theme);
            for (var i = 0, len = nodes.length; i < len; i++) {
                rootul.append(createTreeNode(nodes[i]));
            }
            var content = $('<div/>').addClass('fr-tree-body');
            content.append($('<div/>').addClass('fr-tree-bwrap').append(rootul));
            me.empty();
            me.append(content);
        }

        function createTreeNode(node, triggerEvent) {
            var li = $('<li/>').addClass('fr-tree-node');
            var div = $('<div/>').attr({id : id + '_' + node.getID(), unselectable : 'on'}).addClass(generateClass(node))
                .attr('title', node.getShowValue());
            generatePlaceAndIcon(node, div);
            var textDiv = generateValue(node);
            if (node.isUnselectable()) {
                textDiv.addClass("fr-tree-node-unselectable");
            }
            div.append(textDiv);
            li.append(div);
            if(!dfop.showcheck && node.getcheckstate() === 1) {
                dfop.currentnode = node;
            }
            div.hover(function() {
                    if (!dfop.widget.options.disabled) {
                        $(this).addClass("fr-tree-node-over");
                    }
                },
                function() {
                    $(this).removeClass("fr-tree-node-over");
                });
            div.click(function(e, triggerEvent) {
                if (dfop.widget.options.disabled) {
                    return;
                }

                //b:多选时么必要
                if (dfop.showcheck || node.isUnselectable()) {
                    return;
                }
                if (dfop.currentnode != node && !dfop.beforeSelectItemChange()) {
                    return;
                }
                if (dfop.currentnode) {
                    $("#" + id + "_" + dfop.currentnode.getID()).removeClass("fr-tree-selected");
                }
                // 只返回叶子节点时候，点击带有子节点的项只进行伸缩操作，不进行选中
                // 判断是否有子节点用hasChild 不能用getChildrenLength>0
                if(dfop.selectLeafOnly && node.hasChild()) {
                    expandOrCloseNode(div, $(div.children('img')[0]), node, e);
                    return;
                }
                else{
                    dfop.currentnode = node;
                    div.addClass("fr-tree-selected");
                }
                if (dfop.onnodeclick) {
                    dfop.onnodeclick.call(this, node, triggerEvent);
                }
                e.stopEvent();
            }).dblclick(function(e) {
                if (dfop.widget.options.disabled) {
                    return;
                }
                expandOrCloseNode(div, $(div.children('img')[0]), node, e);
            });
            node.ui = li;
            //wei : loadByLayer，一次只生成1级dom，不管数据有没有加载完成。
            if (node.isLoadComplete() && node.getChildrenLength() > 0 && dfop.loadByLayer !== true) {
                var ul = createWrapUL();
                div.parent('li').append(ul);
                for (var i = 0, len = node.getChildrenLength(); i < len; i++) {
                    ul.append(createTreeNode(node.getChild(i)));
                }
                if (!node.isexpand()) {
                    ul.hide();
                }
            }
            // shoc:搜索过滤的时候,只显示过滤出的节点,其他的结构隐藏
            if(dfop.widget.searchText && !node.isexpand()) {
                li.css({display:'none' });
            }
            return li;
        }

        function createWrapUL() {
            return $("<ul/>").addClass('fr-tree-node-ct').css({'z-index': 0, position: 'static', visibility: 'visible', top: 'auto', left: 'auto'});
        }

        function generateClass(node) {
            var classes = ['fr-tree-node-el'];
            node.hasChild() ? (classes.push(node.isexpand() ? "fr-tree-node-expanded" : "fr-tree-node-collapsed")) :
                (classes.push(node.getnodeicon() ? 'fr-tree-node-' + node.getnodeicon() : "fr-tree-node-leaf"));
            if(node == dfop.currentnode) {
                classes.push("fr-tree-selected")
            }
            classes.push(node.getclasses());
            return classes.join(' ');
        }

        function expandOrCloseNode(div, $expandIcon, node, e) {
            var ul = div.next();
            if ($expandIcon.hasClass(dfop.expandClass) || $expandIcon.hasClass(dfop.expandEndClass)) {
                if (ul.length > 0) {
                    $(ul[0]).show();
                } else {
                    div.addClass("fr-tree-node-loading");
                    node.additionalParameter(allPara());

                    insertNodes(node.getChildren());
                    checkPoint(node.getChildren());
                    div.removeClass("fr-tree-node-loading");
                    if (typeof dfop.afterAjax == 'function'){
                        dfop.afterAjax(node.getChildren());
                    }
                    if (node.getcheckstate() === 1 && dfop.noParent && dfop.selectLeafOnly) {
                        cascade(check, node, node.getcheckstate());
                    }
                }
                if ($expandIcon.hasClass(dfop.expandClass)) {
                    $expandIcon.swapClass(dfop.expandClass, dfop.closeClass);
                } else {
                    $expandIcon.swapClass(dfop.expandEndClass, dfop.closeEndClass);
                }
                div.swapClass("fr-tree-node-collapsed", "fr-tree-node-expanded");
            } else if ($expandIcon.hasClass(dfop.closeClass) || $expandIcon.hasClass(dfop.closeEndClass)) {  //- 号需要收缩
                ul.hide();
                if ($expandIcon.hasClass(dfop.closeClass)) {
                    $expandIcon.swapClass(dfop.closeClass, dfop.expandClass);
                } else {
                    $expandIcon.swapClass(dfop.closeEndClass, dfop.expandEndClass);
                }
                div.swapClass("fr-tree-node-expanded", "fr-tree-node-collapsed");
            }
            var view = dfop.widget.$view;
            if (view && dfop.widget.options.autoFixWidth !== false) {
                view.css('width', 'auto');
                // ie9的ie7标准模式自适应的width,view可能没展开,body展开了
                var maxWidth = Math.max(view.width(), view.children().width(), dfop.widget.options.oriWidth);
                // body太高了右边出现滚动条也得考虑下
                if (view.children().height() > view.height()) {
                    maxWidth += 18;
                }
                view.css('width', maxWidth);
            }
            e.stopEvent();
        }

        function generatePlaceAndIcon(node, div) {
            var span = $('<span/>').addClass('fr-tree-node-indent');
            for (var i = 0, len = node.getAncestorsLength(); i < len; i++) {
                var cs = 'fr-tree-elbow-line';
                if (i === 0) {
                    cs = 'fr-tree-icon';
                }
                span.append(createEmptyIcon().addClass(cs));
            }
            div.append(span);

            var $expandIcon = createEmptyIcon().addClass(generateExpandIconClass(node));
            var $folderIcon = createEmptyIcon();
            $folderIcon.addClass('fr-tree-node-icon-old');
            $expandIcon.click(function(e) {
                if (!dfop.widget.options.disabled) {
                    expandOrCloseNode(div, $expandIcon, node, e);
                }
            });
            div.append($expandIcon);
            div.append($folderIcon);
            if (dfop.showcheck && node.getshowcheck()) {
                var checkIcon = $('<img/>').addClass('fr-tree-node-cb').attr({id : id + '_' + node.getID() + '_cb',
                    src : dfop.cbiconpath + dfop.icons[node.getcheckstate() ? node.getcheckstate() : 0]})
                div.append(checkIcon);
                if (node.isUnselectable()) {
                    checkIcon.addClass("fr-tree-node-unselectable");
                } else {
                    checkIcon.click(function(e) {
                        if (dfop.widget.options.disabled) {
                            return;
                        }
                        var s = node.getcheckstate() !== 1 ? 1 : 0;
                        var r = true;

                        if (dfop.oncheckboxclick) {
                            r = dfop.oncheckboxclick.call(et, node, s);
                        }
                        if (r !== false) {
                            if (dfop.noParent) {
                                if(dfop.selectLeafOnly || dfop.traversal){
                                    cascade(check, node, s);
                                }
                                bubble(check, node, s);
                            } else {
                                check(node, s, 1);
                            }
                        }
                        // 如果selectLeafOnly 那么需要遍历子节点进行勾选之类
                        // 否则当前节点可选 不需要再做遍历 直接把这个节点添加即可
                        if (dfop.selectLeafOnly || dfop.traversal) {
                            // 到树控件的_onEnterPressed处理
                            if (dfop.onnodeclick) {
                                dfop.onnodeclick.call(node);
                            }
                        } else {
                            // 当前节点可选 不会影响其他节点值 直接处理本节点即可
                            var w = dfop.widget;
                            if (w.isComboBoxTree()) {
                                var tValue = node.getValuePath();
                                var tText = node.getShowValue();
                                if (node.getcheckstate() === 1) { // 点击选中
                                    w.value.push(tValue);
                                    w.text.push(tText);
                                } else if(node.getcheckstate() === 0) { // 点击取消选中
                                    for (var i=0; i< w.value.length; i++) {
                                        if (FR.equals(tValue, w.value[i])) {
                                            w.value.remove(w.value[i]);
                                            break;
                                        }
                                    }
                                    w.text.remove(tText);
                                }
                                w._setCompText(w.text);
                                w.editComp.focus();
                            }
                            // 49479 得触发事件
                            w.fireEvent(FR.Events.AFTEREDIT);
                        }
                        e.stopEvent();
                    });
                }
            }
        }

        function makeNodeValue(node, value) {
            if (!value) {
                value = [];
            }
            value.push(node.getValue());
            if (node.getParent()) {
                makeNodeValue(node.getParent(), value);
            } else {
                value = value.reverse();
            }
            return value;
        }

        function createEmptyIcon() {
            return $('<img/>').attr('src', FR.servletURL + '?op=resource&resource=/com/fr/web/core/js/jquerytree/images/s.gif');
        }

        function generateExpandIconClass(node) {
            var cs = [];
            var isend = isLastSon(node);
            if (node.hasChild()) {
                if (node.isexpand()) {

                    cs.push(isend ? dfop.closeEndClass : dfop.closeClass);

                } else {

                    cs.push(isend ? dfop.expandEndClass : dfop.expandClass);

                }
            } else {

                cs.push(isend ? "fr-tree-elbow-end" : "fr-tree-elbow");

            }
            return cs.join(" ");
        }

        function isLastSon(node) {
            if (!node.getParent()) {
                return treenodes[treenodes.length - 1] == node;
            } else {
                return node.getParent().getChild(node.getParent().getChildrenLength() - 1) == node;
            }
        }

        function generateValue(node) {
            return $('<a hideFocus/>').addClass('fr-tree-node-anchor').attr('tabIndex', 1)
                .append($('<span/>').attr('unselectable', 'on').text(node.getShowValue()));
        }

        function check(node, state, type) {
            var pstate = node.getcheckstate();
            if (type === 1) {
                node.setcheckstate(state);
            } else if(dfop.selectLeafOnly || dfop.traversal) {// 上溯
                var cs = [];
                if (node.isLoadComplete()) {
                    cs = node.getChildren();
                }
                var l = cs.length;
                var ch = true;
                for (var i = 0; i < l; i++) {
                    if ((state === 1 && cs[i].getcheckstate() !== 1) || state === 0 && cs[i].getcheckstate() !== 0) {
                        ch = false;
                        break;
                    }
                }
                if (ch) {
                    node.setcheckstate(state);
                } else {
                    node.setcheckstate(2);
                }
            }
            // 改变复选框图标
            if (pstate != node.getcheckstate()) {
                var et = $("#" + id + "_" + node.getID() + "_cb");
                if (et.length === 1) {
                    et.attr("src", dfop.cbiconpath + dfop.icons[node.getcheckstate()]);
                }
            }

        }
        //遍历子节点
        function cascade(fn, item, args) {
            if (!item.isLoaded) {
                item.additionalParameter(allPara());
            }
            if (fn(item, args, 1) !== false) {
                if (item.getChildrenLength() > 0) {
                    var cs = item.getChildren();
                    for (var i = 0, len = cs.length; i < len; i++) {
                        if (dfop.traversal === 1) {
                            fn(cs[i], args, 1);
                        } else if (dfop.traversal === 2) {
                            cascade(fn, cs[i], args);
                        } else if (dfop.traversal === 0 && dfop.selectLeafOnly) {
                            cascade(fn, cs[i], args);
                        }
                    }
                }
            }
        }
        //冒泡的祖先
        function bubble(fn, item, args) {
            fn(item, args, 1);
            var p = item.getParent();
            while (p) {
                if (fn(p, args, 0) === false) {
                    break;
                }
                p = p.getParent();
            }
        }

        function getck(items, c, fn) {
            for (var i = 0, l = items.length; i < l; i++) {
                if(items[i].getcheckstate() === 0 && dfop.selectLeafOnly) {
                    continue;
                }
                items[i].getcheckstate() === 1 && (!(items[i].hasChild()) || !dfop.selectLeafOnly) && c.push(fn(items[i]));
                if (items[i].hasChild()) {
                    if (items[i].getChildrenLength() > 0) {
                        getck(items[i].getChildren(), c, fn);
                    } else if (dfop.selectLeafOnly){
                        c.push(fn(items[i]));
                    }
                }
            }
        }

        function limitedNodes(layer, nodes, ln) {
            if (!layer || !nodes) {
                return;
            }
            if (layer === 1) {
                for(var i = 0, len = nodes.length; i < len; i++) {
                    if (nodes[i].getcheckstate() === 1) {
                        ln.push(nodes[i]);
                    }
                }
            } else {
                for (var i = 0, len = nodes.length; i < len; i++) {
                    if (!nodes[i].isLoadComplete()) {
                        continue;
                    }
                    var ns = nodes[i].getChildren();
                    --layer;
                    limitedNodes(layer, ns, ln);
                }
            }
        }

        me[0].getNodePath = function(node) {
            var curItem = node;
            var resultPath = curItem.data.text;
            curItem = curItem.getParent();
            while(curItem) {
                resultPath = curItem.data.text + '/' + resultPath;
                curItem = curItem.getParent();
            }
            return resultPath;
        }

        me[0].getNodeState = function(node) {
            var result
            var children = node.getChildren();
            var num = 0;
            for(var i = 0; i < children.length; i ++) {
                var item = children[i];
                if(item.getcheckstate() === 1) {
                    num ++;
                } else if(item.getcheckstate() === 2) {
                    return 2;
                }
            }
            if(num === 0) {
                return 0;
            } else if(num === children.length) {
                return 1;
            } else {
                return 2;
            }
        }

        me[0].createTree = function(nodes) {
            createTree(nodes);
        }

        me[0].getNodeValueWithPath = function(node) {
            var resultArray = [];
            var curItem = node;
            resultArray.unshift(curItem.getValue());
            curItem = curItem.getParent();
            while(curItem) {
                resultArray.unshift(curItem.getValue());
                curItem = curItem.getParent();
            }
            return resultArray;
        }

        me[0].getNodeTextWithPath = function(node) {
            var resultArray = [];
            var curItem = node;
            resultArray.unshift(curItem.data.text);
            curItem = curItem.getParent();
            while(curItem) {
                resultArray.unshift(curItem.data.text);
                curItem = curItem.getParent();
            }
            return resultArray;
        }

        me[0].t = {
            getSelectedNodes: function() {
                if (dfop.limitedNode) {
                    return this.getLimitedNodes();
                }
                var s = [];
                getck(treenodes, s, function(node) {
                    return node
                });
                return s;
            },

            getLimitedNodes : function() {
                var lns = [];
                limitedNodes(dfop.limitedNode, treenodes, lns);
                return lns;
            },

            getSelectedValues: function() {
                var s = [];
                getck(treenodes, s, function(node) {
                    return node.getValue()
                });
                return s;
            },
            getSelectedTexts: function(){
                var s = [];
                getck(treenodes, s, function(node) {
                    return node.getShowValue()
                });
                return s;
            },
            getCurrentItem: function() {
                return dfop.currentnode;
            },
            setOptions : function(opts){
                $.extend(dfop, opts);
            }
        };
        return me;
    }
    $.fn.setOptions = function(opts){
        if (this[0].t) {
            this[0].t.setOptions(opts);
        }
    }
    // 保持兼容7.0.4
    $.fn.setTraversal = function(type) {
        if (this[0].t) {
            this[0].t.setOptions({traversal:type});
        }
    }
    //获取所有选中的节点的Value数组
    $.fn.getTSVs = function() {
        if (this[0].t) {
            return this[0].t.getSelectedValues();
        }
        return null;
    }
    //获取所有选中节点的Text数组
    $.fn.getTSTs = function(){
        if (this[0].t) {
            return this[0].t.getSelectedTexts();
        }
        return null;
    }
    //获取所有选中的节点的Item数组
    $.fn.getTSNs = function() {
        if (this[0].t) {
            return this[0].t.getSelectedNodes();
        }
        return null;
    }
    $.fn.getTCT = function() {
        if (this[0].t) {
            return this[0].t.getCurrentItem();
        }
        return null;
    }
    $.fn.getTCTPath = function() {
        if (this[0].t) {
            var curItem = this[0].t.getCurrentItem();
            return this[0].getNodePath(curItem);
        }
        return null;
    }
    //wei : path为1/2/3的则返回数组[1,2,3],针对单选
    $.fn.getTCPValue = function() {
        if (this[0].t) {
            var curItem = this[0].t.getCurrentItem();
            if(!curItem) {
                return null;
            }
            return this[0].getNodeValueWithPath(curItem);
        }
    }
    //wei : 同上，针对多选
    $.fn.getTCPValues = function() {
        if (this[0].t) {
            var selectedNodes = this[0].t.getSelectedNodes();
            var resultArray = [];
            var self = this;
            $.each(selectedNodes, function(idx, item) {
                resultArray.push(self[0].getNodeValueWithPath(item));
            })
            return resultArray;
        }
        return null;
    }

    $.fn.getTCPText = function() {
        if (this[0].t) {
            var curItem = this[0].t.getCurrentItem();
            return this[0].getNodeTextWithPath(curItem);
        }
        return null;
    }
    //wei : 同上，针对多选
    $.fn.getTCPTexts = function() {
        if (this[0].t) {
            var selectedNodes = this[0].t.getSelectedNodes();
            var resultArray = [];
            var self = this;
            $.each(selectedNodes, function(idx, item) {
                resultArray.push(self[0].getNodeTextWithPath(item));
            })
            return resultArray;
        }
        return null;
    }

    $.fn.getTSTPaths = function(){
        if (this[0].t) {
            var selectedNodes = this[0].t.getSelectedNodes();
            var resultArray = [];
            var self = this;
            $.each(selectedNodes, function(idx, item) {
                resultArray.push(self[0].getNodePath(item));
            })
            return resultArray;
        }
        return null;
    }

    //wei : 得到节点的选中状态：0-没选；1-选中；2-不全选
    $.fn.getNodeState = function(node) {
        if(this[0]) {
            return this[0].getNodeState(node);
        }
        return 0;
    }

    //wei : 创建树
    $.fn.createTree = function(nodes) {
        if(this[0]) {
            return this[0].createTree(nodes);
        }
    }
})(jQuery);