;
(function($){
    /**
     * 扁平的下拉(复选)树控件
     * @class FR.OldTreeComboBoxEditor
     * @extends FR.TreeComboBoxEditor
     */
    FR.OldTreeComboBoxEditor = FR.extend(FR.TreeComboBoxEditor, /**@class FR.OldTreeComboBoxEditor */{
        _defaultConfig: function () {
            return $.extend(
                FR.OldTreeComboBoxEditor.superclass._defaultConfig.apply(), {
                    btn_up: "fr-trigger-btn-up-old",
                    btn_down: "fr-trigger-btn-click-old",
                    btn_over:"fr-trigger-btn-over-old",
                    text_focus:"fr-trigger-text-focus-old"
                });
        },
        _createStyle4TriggerBtn : function(){
            this.arrow.switchClass('fr-trigger-center', 'fr-trigger-center-old');
            var $table = $('<table/>').attr({
                border: '0',
                cellPadding: '0',
                cellSpacing: '0'
            }).css({
                width: '100%',
                height: '100%'
            }).appendTo(this.btn);
            var toptr = $('<tr/>').height(1);
            toptr.append($('<td/>').addClass('fr-trigger-top-center'));
            toptr.append($('<td/>').addClass('fr-trigger-top-right'));
            toptr.appendTo($table);
            var eh = this.btn.innerHeight();

            var centertr = this.centertr = $('<tr/>');
            if (eh - 2 > 0) {
                centertr.height(eh - 2);
            }
            centertr.append($('<td/>').addClass('fr-trigger-middle-center-old')
                .append(this.arrow));
            centertr.append($('<td/>').addClass('fr-trigger-middle-right'));
            centertr.appendTo($table);
            var bottomtr = $('<tr/>').height(1);
            bottomtr.append($('<td/>').addClass('fr-trigger-bottom-center'));
            bottomtr.append($('<td/>').addClass('fr-trigger-bottom-right'));
            bottomtr.appendTo($table);
        },
        createTextComp : function(){
            return $("<div class='fr-trigger-text'></div>")
                .appendTo(this.element);
        },
        _createTreeView:function (treeConfig){
            this.$view.oldtreeview(treeConfig);
        },
        fixbtnHeightValue : function(){
            return 0;
        },
        fixbtnWidthValue : function(){
            return 0;
        },
        doResize4Triggerbtn: function(give){
            this.centertr .height(give.height - 2);
        },
        getType: function () {
            return 'treecombobox';
        }

    });
    $.shortcut('oldtreecombobox', FR.OldTreeComboBoxEditor);
})(jQuery);